/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-gateway-msgs-0.6.9-0precise-20150327-1737/msg/RemoteGateway.msg
 *
 */


#ifndef GATEWAY_MSGS_MESSAGE_REMOTEGATEWAY_H
#define GATEWAY_MSGS_MESSAGE_REMOTEGATEWAY_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <gateway_msgs/Rule.h>
#include <gateway_msgs/RemoteRule.h>
#include <gateway_msgs/RemoteRule.h>

namespace gateway_msgs
{
template <class ContainerAllocator>
struct RemoteGateway_
{
  typedef RemoteGateway_<ContainerAllocator> Type;

  RemoteGateway_()
    : name()
    , ip()
    , firewall(false)
    , public_interface()
    , flipped_interface()
    , pulled_interface()  {
    }
  RemoteGateway_(const ContainerAllocator& _alloc)
    : name(_alloc)
    , ip(_alloc)
    , firewall(false)
    , public_interface(_alloc)
    , flipped_interface(_alloc)
    , pulled_interface(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _name_type;
  _name_type name;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _ip_type;
  _ip_type ip;

   typedef uint8_t _firewall_type;
  _firewall_type firewall;

   typedef std::vector< ::gateway_msgs::Rule_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::gateway_msgs::Rule_<ContainerAllocator> >::other >  _public_interface_type;
  _public_interface_type public_interface;

   typedef std::vector< ::gateway_msgs::RemoteRule_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::gateway_msgs::RemoteRule_<ContainerAllocator> >::other >  _flipped_interface_type;
  _flipped_interface_type flipped_interface;

   typedef std::vector< ::gateway_msgs::RemoteRule_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::gateway_msgs::RemoteRule_<ContainerAllocator> >::other >  _pulled_interface_type;
  _pulled_interface_type pulled_interface;




  typedef boost::shared_ptr< ::gateway_msgs::RemoteGateway_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::gateway_msgs::RemoteGateway_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct RemoteGateway_

typedef ::gateway_msgs::RemoteGateway_<std::allocator<void> > RemoteGateway;

typedef boost::shared_ptr< ::gateway_msgs::RemoteGateway > RemoteGatewayPtr;
typedef boost::shared_ptr< ::gateway_msgs::RemoteGateway const> RemoteGatewayConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::gateway_msgs::RemoteGateway_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace gateway_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'gateway_msgs': ['/tmp/buildd/ros-hydro-gateway-msgs-0.6.9-0precise-20150327-1737/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::gateway_msgs::RemoteGateway_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::gateway_msgs::RemoteGateway_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::gateway_msgs::RemoteGateway_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
{
  static const char* value()
  {
    return "c2825a110d4bc0a2e94421a89778e5f4";
  }

  static const char* value(const ::gateway_msgs::RemoteGateway_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xc2825a110d4bc0a2ULL;
  static const uint64_t static_value2 = 0xe94421a89778e5f4ULL;
};

template<class ContainerAllocator>
struct DataType< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
{
  static const char* value()
  {
    return "gateway_msgs/RemoteGateway";
  }

  static const char* value(const ::gateway_msgs::RemoteGateway_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
{
  static const char* value()
  {
    return "###### Gateway information ######\n\
string name\n\
string ip\n\
#TODO blocking status,health\n\
bool firewall\n\
\n\
###### Public Interface ######\n\
\n\
Rule[] public_interface\n\
\n\
\n\
###### Flipped Interface ######\n\
\n\
# Flipped and pulled interfaces would be useful for debugging \n\
#    https://github.com/robotics-in-concert/rocon_multimaster/issues/84\n\
\n\
RemoteRule[] flipped_interface\n\
RemoteRule[] pulled_interface\n\
\n\
###### Foreign Interface ######\n\
\n\
# Q) Should we show these?\n\
# A) Probably not, in the overall scheme of things, \n\
#    it doubles up the information from above\n\
\n\
# RemoteRule[] flipped_in_connections\n\
# RemoteRule[] pulled_connections\n\
\n\
================================================================================\n\
MSG: gateway_msgs/Rule\n\
# Standard gateway connection rule\n\
\n\
# type of connection (from gateway_msgs.msg.Connection)\n\
string type\n\
\n\
# this is the topic/service name or the action base name (a regex is supported)\n\
string name \n\
\n\
# (optional) an optional node name can be provided. if node name is not provided\n\
# then all nodes are matched (also supports regex)\n\
string node\n\
\n\
================================================================================\n\
MSG: gateway_msgs/RemoteRule\n\
# Definition for a flip. It represents either:\n\
#\n\
# 1) an existing flipped connection (from the local gateway)\n\
# 2) a rule that is put on a watchlist\n\
\n\
# The target recipient of the flip\n\
string gateway\n\
\n\
# Connection has the following parameters that need setting\n\
# - name : fully qualified name of the connection (str)\n\
# - type : connection type (str)\n\
#  \n\
# Use one of the types defined in Connection string constants:\n\
#     (publisher, subscriber, service, action_client, action_server)\n\
#\n\
# - node : name of the node it originates from (str)(optional)\n\
#\n\
# Node name is necessary, for instance, if you have multiple subscribers\n\
# publishing to a single topic. Most of the time it is not necessary,\n\
# but in some cases it helps refine the rule. It helps refine the rule.\n\
#\n\
Rule rule\n\
";
  }

  static const char* value(const ::gateway_msgs::RemoteGateway_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.name);
      stream.next(m.ip);
      stream.next(m.firewall);
      stream.next(m.public_interface);
      stream.next(m.flipped_interface);
      stream.next(m.pulled_interface);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct RemoteGateway_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::gateway_msgs::RemoteGateway_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::gateway_msgs::RemoteGateway_<ContainerAllocator>& v)
  {
    s << indent << "name: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.name);
    s << indent << "ip: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.ip);
    s << indent << "firewall: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.firewall);
    s << indent << "public_interface[]" << std::endl;
    for (size_t i = 0; i < v.public_interface.size(); ++i)
    {
      s << indent << "  public_interface[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::gateway_msgs::Rule_<ContainerAllocator> >::stream(s, indent + "    ", v.public_interface[i]);
    }
    s << indent << "flipped_interface[]" << std::endl;
    for (size_t i = 0; i < v.flipped_interface.size(); ++i)
    {
      s << indent << "  flipped_interface[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::gateway_msgs::RemoteRule_<ContainerAllocator> >::stream(s, indent + "    ", v.flipped_interface[i]);
    }
    s << indent << "pulled_interface[]" << std::endl;
    for (size_t i = 0; i < v.pulled_interface.size(); ++i)
    {
      s << indent << "  pulled_interface[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::gateway_msgs::RemoteRule_<ContainerAllocator> >::stream(s, indent + "    ", v.pulled_interface[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // GATEWAY_MSGS_MESSAGE_REMOTEGATEWAY_H
